Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/inc/block-config.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/inc/block-config.php	(revision 13332)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/inc/block-config.php	(revision 13333)
@@ -7,4 +7,9 @@
 
 add_filter( 'wporg_block_navigation_menus', __NAMESPACE__ . '\add_site_navigation_menus' );
+add_filter( 'wporg_query_filter_options_sort', __NAMESPACE__ . '\wporg_query_filter_options_sort' );
+add_filter( 'wporg_query_filter_options_business_model', __NAMESPACE__ . '\wporg_query_filter_options_business_model' );
+add_filter( 'wporg_query_filter_options_plugin_category', __NAMESPACE__ . '\wporg_query_filter_options_plugin_category' );
+add_filter( 'wporg_query_filter_in_form', __NAMESPACE__ . '\wporg_query_filter_in_form' );
+add_filter( 'wporg_query_total_label', __NAMESPACE__ . '\wporg_query_total_label', 10, 2 );
 
 /**
@@ -29,2 +34,120 @@
 	);
 }
+
+function wporg_query_filter_options_sort() {
+	global $wp_query;
+	$orderby = strtolower( $wp_query->query['orderby'] ?? '' );
+	$order   = strtolower( $wp_query->query['order'] ?? '' );
+	$sort     = $orderby . ( $order ? '_' . $order : '' );
+
+	$options = array(
+		'relevance'       => __( 'Relevance', 'wporg-plugins' ),
+		'active_installs' => __( 'Most Used', 'wporg-plugins' ),
+		'rating'          => __( 'Rating', 'wporg-plugins' ),
+		'ratings'         => __( 'Reviews', 'wporg-plugins' ),
+		'last_updated'    => __( 'Recently Updated', 'wporg-plugins' ),
+		'date_desc'       => __( 'Newest', 'wporg-plugins' ),
+		'tested'          => __( 'Tested Up to', 'wporg-plugins' ),
+	);
+
+	// Remove relevance for non-search.
+	if ( ! is_search() ) {
+		unset( $options['relevance'] );
+	} else {
+		// TODO: Temporarily only show relevance on search.
+		$options = [
+			'relevance' => $options['relevance']
+		];
+	}
+
+	$label = __( 'Sort', 'wporg-plugins' );
+	if ( $sort && isset( $options[ $sort ] ) ) {
+		/* translators: 'Sort: Rating' or 'Sort: Most Used', etc. */
+		$label = sprintf( __( 'Sort: %s', 'wporg-plugins' ), $options[ $sort ] );
+	}
+
+	return array(
+		'label'    => $label,
+		'title'    => __( 'Sort', 'wporg-plugins' ),
+		'key'      => 'orderby',
+		'action'   => '',
+		'options'  => $options,
+		'selected' => [ $sort ],
+	);
+}
+
+function wporg_query_filter_options_business_model() {
+	$options = array(
+		'commercial' => __( 'Commercial', 'wporg-plugins' ),
+		'community' => __( 'Community', 'wporg-plugins' ),
+	);
+	$label = __( 'Type', 'wporg-plugins' );
+	if ( get_query_var( 'plugin_business_model' ) && isset( $options[ get_query_var( 'plugin_business_model' ) ] ) ) {
+		$label = sprintf( __( 'Type: %s', 'wporg-plugins' ), $options[ get_query_var( 'plugin_business_model' ) ] );
+	}
+
+	return array(
+		'label'    => $label,
+		'title'    => __( 'Type', 'wporg-plugins' ),
+		'key'      => 'plugin_business_model',
+		'action'   => '',
+		'options'  => $options ,
+		'selected' => [ get_query_var( 'plugin_business_model' ) ],
+	);
+}
+
+function wporg_query_filter_options_plugin_category() {
+	$options = [];
+	foreach ( get_terms( 'plugin_category', [ 'hide_empty' => true ] ) as $term ) {
+		$options[ $term->slug ] = $term->name;
+	}
+
+	$count = count( (array) get_query_var( 'plugin_category' ) );
+	$label = sprintf(
+		/* translators: The dropdown label for filtering, %s is the selected term count. */
+		_n( 'Categories <span>%s</span>', 'Categories <span>%s</span>', number_format_i18n( $count ), 'wporg-plugins' ),
+		$count
+	);
+
+	return array(
+		'label'    => $label,
+		'title'    => __( 'Category', 'wporg-plugins' ),
+		'key'      => 'plugin_category',
+		'action'   => '',
+		'options'  => $options,
+		'selected' => (array) get_query_var( 'plugin_category' ),
+	);
+}
+
+function wporg_query_filter_in_form( $key ) {
+	global $wp_query;
+
+	foreach ( $wp_query->query as $query_var => $values ) {
+		if ( $key === $query_var ) {
+			continue;
+		}
+
+		$array  = is_array( $values );
+		$values = (array) $values;
+		foreach ( $values as $value ) {
+			// Support for tax archives... TODO Hacky..
+			// Realistically we should just ditch these and have all of the filters hit /search/?stuff=goes&here
+			if ( is_tax() && $value === ( get_queried_object()->slug ?? '' ) ) {
+				continue;
+			} elseif ( is_search() && 's' === $query_var ) {
+				continue;
+			}
+
+			printf(
+				'<input type="hidden" name="%s" value="%s" />',
+				esc_attr( $query_var ) . ( $array ? '[]' : '' ),
+				esc_attr( $value )
+			);
+		}
+	}
+
+}
+
+function wporg_query_total_label( $label, $count ) {
+	return _n( '%s plugin', '%s plugins', $count, 'wporg-plugins' );
+}
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/archive-page/render.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/archive-page/render.php	(revision 13332)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/archive-page/render.php	(revision 13333)
@@ -24,4 +24,5 @@
 	// NOTE: wp-block-group-is-layout-grid is here as `wp-block-query-is-layout-grid`  is not supported yet by `wporg/link-wrapper`.
 	echo do_blocks( <<<BLOCKS
+		<!-- wp:wporg/filter-bar /-->
 		<!-- wp:query {"tagName":"div","className":"plugin-cards"} -->
 		<div class="wp-block-query plugin-cards">
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/filter-bar/render.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/filter-bar/render.php	(revision 13332)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/filter-bar/render.php	(revision 13333)
@@ -13,46 +13,23 @@
 }
 
-$local_nav_items = array(
-	'' => __( 'All', 'wporg-plugins' ),
-	'community' => __( 'Community', 'wporg-plugins' ),
-	'commercial' => __( 'Commercial', 'wporg-plugins' ),
+echo do_blocks(
+	'<!-- wp:group {"align":"wide","className":"wporg-filter-bar wporg-plugins__filters wporg-plugins__filters__no-count","layout":{"type":"flex","flexWrap":"wrap","justifyContent":"space-between"}} -->
+	<div class="wp-block-group alignwide wporg-filter-bar wporg-plugins__filters wporg-plugins__filters__no-count">
+		<!-- wp:group {"className":"wporg-plugins__filters__search","layout":{"type":"flex","flexWrap":"wrap"}} -->
+		<div class="wp-block-group wporg-plugins__filters__search">
+			<!-- wp:search {"showLabel":false,"placeholder":"' . esc_attr__( 'Search plugins', 'wporg-plugins' ) . '","width":100,"widthUnit":"%","buttonText":"' . esc_attr__( 'Search plugins', 'wporg-plugins' ) . '","buttonPosition":"button-inside","buttonUseIcon":true,"className":"is-style-secondary-search-control"} /-->
+			<!-- wp:query {"inherit":true} -->
+				<!-- wp:wporg/query-total /-->
+			<!-- /wp:query -->
+		</div>
+		<!-- /wp:group -->
+		<!-- wp:group {"style":{"spacing":{"blockGap":"0"}},"className":"wporg-query-filters","layout":{"type":"flex","flexWrap":"nowrap"}} -->
+		<div class="wp-block-group wporg-query-filters">
+			<!-- wp:wporg/query-filter {"key":"plugin_category"} /-->
+			<!-- wp:wporg/query-filter {"key":"business_model","multiple":false} /-->
+			<!-- wp:wporg/query-filter {"key":"sort","multiple":false} /-->
+		</div>
+		<!-- /wp:group -->
+	</div>
+	<!-- /wp:group -->'
 );
-
-?>
-
-<div class="wporg-filter-bar alignwide">
-	<nav class="wporg-filter-bar__navigation" aria-label="<?php esc_html_e( 'Plugin filters', 'wporg-plugins' ); ?>">
-		<ul>
-		<?php
-		foreach ( $local_nav_items as $slug => $label ) {
-			$class = '';
-			if (
-				// URL contains this filter.
-				( $slug === ( $_GET['plugin_business_model'] ?? false ) ) ||
-				// Set the All item active if no business model is selected.
-				( ! $slug && empty( $_GET['plugin_business_model'] ) )
-			) {
-				$class = 'is-active';
-			}
-
-			if ( $slug ) {
-				$url = add_query_arg( array( 'plugin_business_model' => $slug ) );
-			} else {
-				$url = remove_query_arg( 'plugin_business_model' );
-			}
-
-			// Reset pagination.
-			$url = remove_query_arg( 'paged', $url );
-			$url = preg_replace( '!/page/\d+/?!i', '/', $url );
-
-			printf(
-				'<li class="page_item"><a class="%1$s" href="%2$s">%3$s</a></li>',
-				esc_attr( $class ),
-				esc_url( $url ),
-				esc_html( $label )
-			);
-		}
-		?>
-		</ul>
-	</nav>
-</div>
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/search-page/render.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/search-page/render.php	(revision 13332)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/js/build/blocks/search-page/render.php	(revision 13333)
@@ -25,4 +25,5 @@
 	// NOTE: wp-block-group-is-layout-grid is here as `wp-block-query-is-layout-grid` is not supported yet by `wporg/link-wrapper`.
 	echo do_blocks( <<<BLOCKS
+		<!-- wp:wporg/filter-bar /-->
 		<!-- wp:query {"tagName":"div","className":"plugin-cards"} -->
 		<div class="wp-block-query plugin-cards">
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/archive-page/render.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/archive-page/render.php	(revision 13332)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/archive-page/render.php	(revision 13333)
@@ -24,4 +24,5 @@
 	// NOTE: wp-block-group-is-layout-grid is here as `wp-block-query-is-layout-grid`  is not supported yet by `wporg/link-wrapper`.
 	echo do_blocks( <<<BLOCKS
+		<!-- wp:wporg/filter-bar /-->
 		<!-- wp:query {"tagName":"div","className":"plugin-cards"} -->
 		<div class="wp-block-query plugin-cards">
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/filter-bar/render.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/filter-bar/render.php	(revision 13332)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/filter-bar/render.php	(revision 13333)
@@ -13,46 +13,23 @@
 }
 
-$local_nav_items = array(
-	'' => __( 'All', 'wporg-plugins' ),
-	'community' => __( 'Community', 'wporg-plugins' ),
-	'commercial' => __( 'Commercial', 'wporg-plugins' ),
+echo do_blocks(
+	'<!-- wp:group {"align":"wide","className":"wporg-filter-bar wporg-plugins__filters wporg-plugins__filters__no-count","layout":{"type":"flex","flexWrap":"wrap","justifyContent":"space-between"}} -->
+	<div class="wp-block-group alignwide wporg-filter-bar wporg-plugins__filters wporg-plugins__filters__no-count">
+		<!-- wp:group {"className":"wporg-plugins__filters__search","layout":{"type":"flex","flexWrap":"wrap"}} -->
+		<div class="wp-block-group wporg-plugins__filters__search">
+			<!-- wp:search {"showLabel":false,"placeholder":"' . esc_attr__( 'Search plugins', 'wporg-plugins' ) . '","width":100,"widthUnit":"%","buttonText":"' . esc_attr__( 'Search plugins', 'wporg-plugins' ) . '","buttonPosition":"button-inside","buttonUseIcon":true,"className":"is-style-secondary-search-control"} /-->
+			<!-- wp:query {"inherit":true} -->
+				<!-- wp:wporg/query-total /-->
+			<!-- /wp:query -->
+		</div>
+		<!-- /wp:group -->
+		<!-- wp:group {"style":{"spacing":{"blockGap":"0"}},"className":"wporg-query-filters","layout":{"type":"flex","flexWrap":"nowrap"}} -->
+		<div class="wp-block-group wporg-query-filters">
+			<!-- wp:wporg/query-filter {"key":"plugin_category"} /-->
+			<!-- wp:wporg/query-filter {"key":"business_model","multiple":false} /-->
+			<!-- wp:wporg/query-filter {"key":"sort","multiple":false} /-->
+		</div>
+		<!-- /wp:group -->
+	</div>
+	<!-- /wp:group -->'
 );
-
-?>
-
-<div class="wporg-filter-bar alignwide">
-	<nav class="wporg-filter-bar__navigation" aria-label="<?php esc_html_e( 'Plugin filters', 'wporg-plugins' ); ?>">
-		<ul>
-		<?php
-		foreach ( $local_nav_items as $slug => $label ) {
-			$class = '';
-			if (
-				// URL contains this filter.
-				( $slug === ( $_GET['plugin_business_model'] ?? false ) ) ||
-				// Set the All item active if no business model is selected.
-				( ! $slug && empty( $_GET['plugin_business_model'] ) )
-			) {
-				$class = 'is-active';
-			}
-
-			if ( $slug ) {
-				$url = add_query_arg( array( 'plugin_business_model' => $slug ) );
-			} else {
-				$url = remove_query_arg( 'plugin_business_model' );
-			}
-
-			// Reset pagination.
-			$url = remove_query_arg( 'paged', $url );
-			$url = preg_replace( '!/page/\d+/?!i', '/', $url );
-
-			printf(
-				'<li class="page_item"><a class="%1$s" href="%2$s">%3$s</a></li>',
-				esc_attr( $class ),
-				esc_url( $url ),
-				esc_html( $label )
-			);
-		}
-		?>
-		</ul>
-	</nav>
-</div>
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/search-page/render.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/search-page/render.php	(revision 13332)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-plugins-2024/src/blocks/search-page/render.php	(revision 13333)
@@ -25,4 +25,5 @@
 	// NOTE: wp-block-group-is-layout-grid is here as `wp-block-query-is-layout-grid` is not supported yet by `wporg/link-wrapper`.
 	echo do_blocks( <<<BLOCKS
+		<!-- wp:wporg/filter-bar /-->
 		<!-- wp:query {"tagName":"div","className":"plugin-cards"} -->
 		<div class="wp-block-query plugin-cards">
